package me.Demon.DemonSystemShop;

import me.Demon.DemonMySql;
import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonSystemShop.Buy.BuyShop;
import me.Demon.DemonSystemShop.Buy.ExpShop;
import me.Demon.DemonSystemShop.DayShop.BuyShopPro;
import me.Demon.DemonSystemShop.DayShop.DayShopAPI;
import me.Demon.DemonSystemShop.Minion.MinionShop;
import me.Demon.DemonSystemShop.Sell.BlockShop;
import me.Demon.DemonSystemShop.Sell.MoneyShop;
import me.Demon.DemonSystemShop.Sell.SellShop;
import me.Demon.DemonSystemShop.util.ItemNameUtil;
import me.Demon.DemonSystemShop.util.SqlUtil;
import me.Demon.DemonSystemShop.util.database.SqlManager;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import org.bukkit.plugin.Plugin;
import org.bukkit.plugin.java.JavaPlugin;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

public class Main extends JavaPlugin {

    public static String pluginName = "系统商店";
    private SqlUtil sqlUtil;
    private SqlManager sqlManager;
    public static Main plugin;
    public static boolean isJetsMinions = false;
    public static String prefix = "§7[§6战争领域§7] §f";

    public static HashMap<String, Integer> BuyItemsMap = new HashMap<>();
    public static List<String> BuyItemsList = new ArrayList<>();
    public static File ReDatafile = new File("plugins/DemonSystemShop", "Log.yml");
    public static FileConfiguration RdDataG = YamlConfiguration.loadConfiguration(ReDatafile);

    public static void saveRdDataConfig() {
        try {
            RdDataG.save(ReDatafile);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static HashMap<Player, DayShopAPI> dataAPI = new HashMap<>();

    public SqlUtil getSqlUtil() {
        return sqlUtil;
    }

    public SqlManager getSqlManager() {
        return sqlManager;
    }

    @Override
    public void onEnable() {
        plugin = this;
        saveDefaultConfig();
        ItemNameUtil.inits(plugin);
        Plugin JetsMinions = Bukkit.getPluginManager().getPlugin("JetsMinions");
        if (JetsMinions != null) {
            isJetsMinions = true;
        }
        Bukkit.getServer().getPluginManager().registerEvents(new MinionShop(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new BuyShop(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new SellShop(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new BuyShopPro(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new BlockShop(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new MoneyShop(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new ExpShop(), plugin);
        Bukkit.getConsoleSender().sendMessage("§e[系统商城] §r正在启动插件...");
        // 数据库配置
        sqlManager = new SqlManager(this);
        String SQL_Host = DemonMySql.SQL_Host;
        String SQL_Port = DemonMySql.SQL_Port;
        String SQL_Database = DemonMySql.SQL_Database;
        String SQL_Users = DemonMySql.SQL_Users;
        String SQL_Password = DemonMySql.SQL_Password;
        sqlUtil = new SqlUtil(this, SQL_Host, SQL_Port, SQL_Database, SQL_Users, SQL_Password);
        sqlManager.createTable();
        loadBuyItemsMap();
        // 数据库配置
        for (Player p : Bukkit.getOnlinePlayers()) {
            if (Main.dataAPI.get(p) == null) {
                Main.dataAPI.put(p, new DayShopAPI(p));
            }
        }
    }

    public void loadBuyItemsMap() {
        FileConfiguration yml = Main.plugin.getConfig();
        for (String slot_key : yml.getConfigurationSection("BuyShop").getKeys(false)) {
            ItemStack item = yml.getItemStack("BuyShop." + slot_key + ".items");
            int price = (int) (yml.getInt("BuyShop." + slot_key + ".price") * 1.3);
            String type = String.valueOf(item.getType());
            BuyItemsMap.put(type, price);
            BuyItemsList.add(type);
        }
    }

    @Override
    public void onDisable() {
        getSqlUtil().closeConnection();
        Bukkit.getConsoleSender().sendMessage("§e[系统商城] §r正在关闭插件...");
    }

    public boolean onCommand(CommandSender sender, Command cmd, String Command, String[] args) {
        if (Command.equalsIgnoreCase("systemshop")) {
            if (args.length == 1 && args[0].equalsIgnoreCase("buyshop")) {
                BuyShop.OpenGui((Player) sender);
            }
            if (args.length == 2 && args[0].equalsIgnoreCase("buyshop")) {
                Player player = Bukkit.getPlayer(args[1]);
                if (player != null) {
                    BuyShop.OpenGui(player);
                }
            }
            if (args.length == 1 && args[0].equalsIgnoreCase("jiqiren")) {
                MinionShop.OpenGui((Player) sender);
            }
            if (args.length == 2 && args[0].equalsIgnoreCase("jiqiren")) {
                Player player = Bukkit.getPlayer(args[1]);
                if (player != null) {
                    MinionShop.OpenGui(player);
                }
            }
            if (args.length == 1 && args[0].equalsIgnoreCase("sellshop")) {
                SellShop.OpenGui((Player) sender);
            }
            if (args.length == 2 && args[0].equalsIgnoreCase("sellshop")) {
                Player player = Bukkit.getPlayer(args[1]);
                if (player != null) {
                    SellShop.OpenGui(player);
                }
            }
            if (args.length == 1 && args[0].equalsIgnoreCase("dayshop")) {
                BuyShopPro.OpenGui((Player) sender);
            }
            if (args.length == 2 && args[0].equalsIgnoreCase("dayshop")) {
                Player player = Bukkit.getPlayer(args[1]);
                if (player != null) {
                    BuyShopPro.OpenGui(player);
                }
            }
            if (args.length == 1 && args[0].equalsIgnoreCase("blockshop")) {
                BlockShop.OpenGui((Player) sender);
            }
            if (args.length == 2 && args[0].equalsIgnoreCase("blockshop")) {
                Player player = Bukkit.getPlayer(args[1]);
                if (player != null) {
                    BlockShop.OpenGui(player);
                }
            }
            if (args.length == 1 && args[0].equalsIgnoreCase("moneyshop")) {
                MoneyShop.OpenGui((Player) sender);
            }
            if (args.length == 2 && args[0].equalsIgnoreCase("moneyshop")) {
                Player player = Bukkit.getPlayer(args[1]);
                if (player != null) {
                    MoneyShop.OpenGui(player);
                }
            }
            if (args.length == 1 && args[0].equalsIgnoreCase("expshop")) {
                ExpShop.OpenGui((Player) sender);
            }
            if (args.length == 2 && args[0].equalsIgnoreCase("expshop")) {
                Player player = Bukkit.getPlayer(args[1]);
                if (player != null) {
                    ExpShop.OpenGui(player);
                }
            }
        }
        return false;
    }

    public static String getDayRandomType() {
        List<String> list = new ArrayList<>(Main.BuyItemsList);
        int suijishu = (DemonAPI.getRandomInt(list.size(), 1) - 1);
        return list.get(suijishu);
    }
}
